
#ifndef __BZIP2ARCHIVE_H__
#define __BZIP2ARCHIVE_H__

#include "Archive/Archive.h"

class BZip2Archive : public TreelessArchive
{

public:
	BZip2Archive();
	~BZip2Archive();

	// Opening
	bool	open(MemChunk& mc) override;

	// Writing/Saving
	bool	write(MemChunk& mc, bool update = true) override;

	// Misc
	bool	loadEntryData(ArchiveEntry* entry) override;

	// Entry addition/removal
	ArchiveEntry*	addEntry(
						ArchiveEntry* entry,
						unsigned position = 0xFFFFFFFF,
						ArchiveTreeNode* dir = nullptr,
						bool copy = false
					) override { return nullptr; }
	ArchiveEntry*	addEntry(
						ArchiveEntry* entry,
						string add_namespace,
						bool copy = false
					) override { return nullptr; }
	bool			removeEntry(ArchiveEntry* entry) override { return false ; }

	// Entry modification
	bool	renameEntry(ArchiveEntry* entry, string name) override { return false ; }

	// Entry moving
	bool	swapEntries(ArchiveEntry* entry1, ArchiveEntry* entry2) override { return false ; }
	bool	moveEntry(
				ArchiveEntry* entry,
				unsigned position = 0xFFFFFFFF,
				ArchiveTreeNode* dir = nullptr
			) override { return false ; }

	// Search
	ArchiveEntry*			findFirst(SearchOptions& options) override;
	ArchiveEntry*			findLast(SearchOptions& options) override;
	vector<ArchiveEntry*>	findAll(SearchOptions& options) override;

	// Static functions
	static bool isBZip2Archive(MemChunk& mc);
	static bool isBZip2Archive(string filename);
};

#endif //__BZIP2ARCHIVE_H__
